#include "OffspringGenerator.h"

//vector<Individual>shuffle_rangeǥåե뤷Ƥ
void OffspringGenerator::neighborhood_shuffle(){
	int shuffle_range;
	double width_rate;
 
	if(parameter->getPopulationSize()>50){
		width_rate=0.045;
	}
	else if(parameter->getPopulationSize()>10){
		width_rate=0.1;
	}
	else if(parameter->getPopulationSize()>2){
		width_rate=0.5;
	}
	else width_rate=1.0;

	shuffle_range=(int) (parameter->getPopulationSize()*width_rate);

	int tmp=0;
	for(int i=0;shuffle_range*(i+1)<parameter->getPopulationSize()-1;i++){
		shuffle_indiv(i*shuffle_range,(i+1)*shuffle_range-1,mating);
		tmp=i;
	}
	shuffle_indiv((tmp+1)*shuffle_range,parameter->getPopulationSize()-1,mating);

}

//vector<Individual>startendδ֤ǥåե
void OffspringGenerator::shuffle_indiv(int start,int end,vector<Individual>& population){
	for(int i=start;i<end;i++){
		int changeIndex = randomGenerator->randomInt(i,end+1);
		Individual tmp = population[changeIndex];
		population[changeIndex]=population[i];
		population[i]=tmp;
	}
}

vector<Individual>& OffspringGenerator::getParents(){

	if(pointer!=0){
		for(int i=0;i<2;i++){
			tmp[i]=mating[pointer];
			pointer--;
		}
	}
	else{
		cout << "getParents error" << endl;
		exit(0);
	}
	return tmp;
}

void OffspringGenerator::getChild(vector<Individual>& parents){
	parents[0].crossover(parents[1]);
	tmp[0]=parents[0];
	tmp[1]=parents[1];
}
	
		
///////////////////////////////////////////////////////
ObjectiveNeighborhoodSort::ObjectiveNeighborhoodSort(int gene){
	 generation = gene;

}
	
void ObjectiveNeighborhoodSort::makePairs(vector<Individual>& population){
	
	for(int i=0;i<population.size();i++){
		mating.push_back(population[i]);
	}
	//ȤȤܤŪؿΥǥå򥻥å
	int sortIndex = generation % parameter->getObjectiveNum();
	sort_by_objective(sortIndex,0,parameter->getPopulationSize()-1,mating);
	
}
//objnumܤŪؿvector<Individual>firstendޤǥȤ
void ObjectiveNeighborhoodSort::sort_by_objective(int objnum,int first,int end,vector<Individual>& pop){
	int i,j;
	double piv;
	Individual temp(pop[0]);
	
	piv=pop[(first+end)/2].getobjective(objnum);
	i=first;
	j=end;
	
	while(true){
		while(pop[i].getobjective(objnum)>piv){
			i++;
		}
		while(pop[j].getobjective(objnum)<piv){
			j--;
		}
		if(i>=j) break;
		temp=pop[i];
		pop[i]=pop[j];
		pop[j]=temp;
		i++;
		j--;
	}
	if(first<i-1){
		sort_by_objective(objnum,first,i-1,pop);
	}
	if(j+1<end){
		sort_by_objective(objnum,j+1,end,pop);
	}
}
/////////////////////////////////////////////////////////////////////////
VariableNeighborhoodSort::VariableNeighborhoodSort(){
}

void VariableNeighborhoodSort::makePairs(vector<Individual>& population){

	vector<Individual> beforesort; //θηǼ
	beforesort.resize(population.size());
	for(int i=0;i<population.size();i++){
		beforesort[i]=population[i];
	}
	//˽˳ǼƤ
	vector<Individual> aftersort;  //ȤνäΤǼƤ
	aftersort.resize(population.size());
	int start = randomGenerator->randomInt(0,population.size());
	aftersort[0]=beforesort[start];
	//aftersort˰ܤäΤbeforeȤ
	vector<Individual>::iterator itr;
	itr = beforesort.begin()+start;
	beforesort.erase(itr);

	//population[start]ᤤν˥
	//population[start]˶ᤤΤʤ飳aftersort˳Ǽ
	//population[]äȤᤤΤӡaftersort˳Ǽ
	for(int i=1;i<population.size();i++){
		int index=0;
		double minDistance;
		minDistance = aftersort[i-1].getDistanceVariable(beforesort[0]);

		for(int j=1;j<beforesort.size();j++){
			double d;
			d = aftersort[i-1].getDistanceVariable(beforesort[j]);
			if(minDistance > d){
				index = j;
				minDistance = d;                  	
			}
		}
		//ֶᤤΤޤäΤ
		aftersort[i]=beforesort[index];
		vector<Individual>::iterator itr2;
		itr2 = beforesort.begin()+index;
		beforesort.erase(itr2);

	}
	for(int i=0;i<population.size();i++){
		mating.push_back(aftersort[i]);
	}
}
