#include "SPEA2ranking.h"

//============================================
//	class SPEA2ranking
//============================================
//󥹥ȥ饯
SPEA2ranking::SPEA2ranking(Parameter& para){
	archiveSize=para.getPopulationSize();

}
//õ콸ġŪؿ֡߷ѿ֤ƥ󥭥
void SPEA2ranking::spea2ranking(vector<Individual>& population,
	                            vector<Individual>& objarchive,
	                            vector<Individual>& vararchive){
	//archiveSize-1populationarchiveSize2*archiveSize-1objArchive2*archiveSize3*archiveSizevarArchive
	bool iDominatedByj[3*archiveSize][3*archiveSize];		
	//falseǽ
	for(int i=0;i<3*archiveSize;i++){
		for(int j=0;j<3*archiveSize;j++){
			iDominatedByj[i][j]=false;
		}
	}
	
	//ä󥯤0˥å
	for(int i=0;i<population.size();i++){
		population[i].setrank(0);
		objarchive[i].setrank(0);
		vararchive[i].setrank(0);	
	}
	
	//õ콸ĤθΤˤĤơͥطߤ
	for(int i=0;i<population.size();i++){
		if(population[i].getisFeasible()==true){//¹ԲǽΰθΤФ
			//õ콸Ĥ
			for(int j=0;j<population.size();j++){
				if(i!=j){
					//ij˻ۤƤiDominatedByj[i][j]true
					if(population[i].bedominated(population[j])==true
				   	&& population[j].getisFeasible()==true){
						iDominatedByj[i][j] = true;
					}
				}
			}
			//Ūؿ֤
			int jstart = population.size();
			int jend = jstart + objarchive.size();
			for(int j=jstart;j<jend;j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(population[i].bedominated(objarchive[j-jstart])==true
				   && objarchive[j-jstart].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}			
			//߷ѿ֤
			jstart = jend;
			jend = jend + vararchive.size();
			for(int j=jstart;j<jend;j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(population[i].bedominated(vararchive[j-jstart])==true
				   && vararchive[j-jstart].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}
		}			
	}
	//Ūؿ֤ˤĤơͥطߤ
	int istart = population.size();
	int iend = istart + objarchive.size();
	for(int i=istart;i<iend;i++){
		if(objarchive[i-istart].getisFeasible()==true){//¹ԲǽΰθΤФ
			//õ콸Ĥ
			for(int j=0;j<population.size();j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(objarchive[i-istart].bedominated(population[j])==true
				   && population[j].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}
			//Ūؿ֤
			int jstart = population.size();
			int jend = jstart + objarchive.size();
			for(int j=jstart;j<jend;j++){
				if(i!=j){
					//ij˻ۤƤiDominatedByj[i][j]true
					if(objarchive[i-istart].bedominated(objarchive[j-jstart])==true
					   && objarchive[j-jstart].getisFeasible()==true){
						iDominatedByj[i][j] = true;
					}
				}
			}			
			//߷ѿ֤
			jstart = jend;
			jend = jend + vararchive.size();
			for(int j=jstart;j<jend;j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(objarchive[i-istart].bedominated(vararchive[j-jstart])==true
				   && vararchive[j-jstart].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}			
		}
	}
	//߷ѿ֤ˤĤơͥطߤ
	istart = iend;
	iend = iend + vararchive.size();
	for(int i=istart;i<iend;i++){
		if(vararchive[i-istart].getisFeasible()==true){//¹ԲǽΰθΤФ
			//õ콸Ĥ
			for(int j=0;j<population.size();j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(vararchive[i-istart].bedominated(population[j])==true
				   && population[j].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}
			//Ūؿ֤
			int jstart = population.size();
			int jend = jstart + objarchive.size();
			for(int j=jstart;j<jend;j++){
				//ij˻ۤƤiDominatedByj[i][j]true
				if(vararchive[i-istart].bedominated(objarchive[j-jstart])==true
				   && objarchive[j-jstart].getisFeasible()==true){
					iDominatedByj[i][j] = true;
				}
			}			
			//߷ѿ֤
			jstart = jend;
			jend = jend + vararchive.size();
			for(int j=jstart;j<jend;j++){
				if(i!=j){
					//ij˻ۤƤiDominatedByj[i][j]true
					if(vararchive[i-istart].bedominated(vararchive[j-jstart])==true
					   && vararchive[j-jstart].getisFeasible()==true){
						iDominatedByj[i][j] = true;
					}
				}
			}			
		}
	}
	
	//ۤƤοƤ
	//objarcDominateNum[i]=5פŪؿiܤθΤϣλۤƤȤ
	int* popDominateNum = new int[population.size()];
	for(int i=0;i<population.size();i++){
		popDominateNum[i]=0; //ǽ
	}
	int* objarcDominateNum = new int[objarchive.size()];
	for(int i=0;i<objarchive.size();i++){
		objarcDominateNum[i]=0; //ǽ
	}
	int* vararcDominateNum = new int[vararchive.size()];
	for(int i=0;i<vararchive.size();i++){
		vararcDominateNum[i]=0; //ǽ
	}
	
	//popDominateNumĤpopulationۤƤΤο
	for(int j=0;j<population.size();j++){
		for(int i=0;i<3*archiveSize;i++){
			if(iDominatedByj[i][j]==true){
				popDominateNum[j]++;
			}
		}
	}
	//objarcDominateNumĤ
	int jstart = population.size();
	int jend = jstart + objarchive.size();
	for(int j=jstart;j<jend;j++){
		for(int i=0;i<3*archiveSize;i++){
			if(iDominatedByj[i][j]==true){
				objarcDominateNum[j-jstart]++;
			}
		}
	}
	//vararcDominateNumĤ
	jstart = jend;
	jend = jend + vararchive.size();
	for(int j=jstart;j<jend;j++){
		for(int i=0;i<3*archiveSize;i++){
			if(iDominatedByj[i][j]==true){
				vararcDominateNum[j-jstart]++;
			}
		}
	}
	//ƱΤΥ󥯤򲼤
	//populationӤ
	for(int i=0;i<population.size();i++){
		for(int j=i+1;j<population.size();j++){
			if(population[i]==population[j]){
				population[j].setrank(1);
			}
		}
		for(int j=0;j<objarchive.size();j++){
			if(population[i]==objarchive[j]){
				objarchive[j].setrank(1);
			}
		}
		for(int j=0;j<vararchive.size();j++){
			if(population[i]==vararchive[j]){
				vararchive[j].setrank(1);
			}
		}
	}
	//objarchiveӤ
	for(int i=0;i<objarchive.size();i++){
		for(int j=i+1;j<objarchive.size();j++){
			if(objarchive[i]==objarchive[j]){
				objarchive[j].setrank(1);
			}
		}
		for(int j=0;j<vararchive.size();j++){
			if(objarchive[i]==vararchive[j]){
				vararchive[j].setrank(1);
			}
		}
	}
	//vararchiveӤ
	for(int i=0;i<vararchive.size();i++){
		for(int j=i+1;j<vararchive.size();j++){
			if(vararchive[i]==vararchive[j]){
				vararchive[j].setrank(1);
			}
		}
	}
	
	//õ콸Ĥ˥󥯤򥻥å
	for(int i=0;i<population.size();i++){
		int rank=population[i].getrank();
		//飹ޤǤõ콸ĤȤӤʬ
		for(int j=0;j<population.size();j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + popDominateNum[j];
			}
		}
		//飱ޤǤŪؿ֤ȤӤʬ
		jstart = population.size();
		jend = jstart + objarchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + objarcDominateNum[j-jstart];
			}
		}
		//飲ޤǤ߷ѿ֤ȤӤʬ
		jstart = jend;
		jend = jend+vararchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + vararcDominateNum[j-jstart];
			}
		}
		//õ콸Ĥiܤrank򥻥å
		population[i].setrank(rank);			
	}
	//Ūؿ֤˥󥯤򥻥å
	istart = population.size();
	iend = istart + objarchive.size();
	for(int i=istart;i<iend;i++){
		int rank=objarchive[i-istart].getrank();
		//飹ޤǤõ콸ĤȤӤʬ
		for(int j=0;j<population.size();j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + popDominateNum[j];
			}
		}
		//飱ޤǤŪؿ֤ȤӤʬ
		jstart = population.size();
		jend = jstart + objarchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + objarcDominateNum[j-jstart];
			}
		}
		//飲ޤǤ߷ѿ֤ȤӤʬ
		jstart = jend;
		jend = jend+vararchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + vararcDominateNum[j-jstart];
			}
		}
		//Ūؿ֤iܤrank򥻥å
		objarchive[i-istart].setrank(rank);			
	}
	//߷ѿ֤˥󥯤򥻥å
	istart = iend;
	iend = istart + vararchive.size();
	for(int i=istart;i<iend;i++){
		int rank=vararchive[i-istart].getrank();
		//飹ޤǤõ콸ĤȤӤʬ
		for(int j=0;j<population.size();j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + popDominateNum[j];
			}
		}
		//飱ޤǤŪؿ֤ȤӤʬ
		jstart = population.size();
		jend = jstart + objarchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + objarcDominateNum[j-jstart];
			}
		}
		//飲ޤǤ߷ѿ֤ȤӤʬ
		jstart = jend;
		jend = jend+vararchive.size();
		for(int j=jstart;j < jend;j++){
			if(iDominatedByj[i][j]==true){
				rank = rank + vararcDominateNum[j-jstart];
			}
		}
		//߷ѿ֤iܤrank򥻥å
		vararchive[i-istart].setrank(rank);			
	}
	
	delete [] popDominateNum;
	delete [] objarcDominateNum;
	delete [] vararcDominateNum;
	
}
