#include "GrayCoder.h"

//============================================
//	class GrayCoder
//============================================
GrayCoder::GrayCoder(){
}
//ӥåĹlengthΥ쥤grayStirngǥɤint֤
int GrayCoder::graydecode(int* grayString,int length){
	int n;
	int* binString;
	binString = new int[length];
	GrayToBinary(grayString ,binString,length);
	n = bindecode(binString,length);
	delete [] binString;
	return n;
}
//ӥåĹlengthΥХʥꥳbinStringǥɤint֤
int GrayCoder::bindecode(int* binString,int length){
	int n=0;
	for(int i=length-1;i>=0;i--){
		n+=(1<<(length-1-i))*binString[i];
	}
	return n;
}
//ӥåĹlengthΥ쥤ɤХʥꥳɤѴ
void GrayCoder::GrayToBinary(int* grayString,int* binString,int length){
	binString[0] = grayString[0];
	for(int i=1;i<length;i++){
		binString[i] = (int) (binString[i-1]^grayString[i]);
	}
}
//ӥåĹlengthΥХʥꥳɤ򥰥쥤ɤѴ
void GrayCoder::BinaryToGray(int* binString,int* grayString,int length){
	grayString[0] = binString[0];
	for(int i=1;i<length;i++){
		grayString[i] = (int) (binString[i-1]^binString[i]);
	}
}
//numberӥåĹlengthǥХʥꥳǥ
void GrayCoder::binencode(int number,int length,int* binString){
	for(int i=length-1;i>=0;i--){
		binString[i] = (int) (number%2);
		number = number/2;
	}
}
//numberӥåĹlengthǥ쥤ǥ
void GrayCoder::grayencode(int number,int length,int* grayString){
	int* binString;
	binString = new int[length];
	binencode(number,length,binString);
	BinaryToGray(binString,grayString,length);
	delete [] binString;
}
//GrayCoder󥹥󥹤֤
GrayCoder& GrayCoder::getInstance(){
	static GrayCoder* coder;
	if(coder == 0){
		coder = new GrayCoder;
	}
	return *coder;
}

