#ifndef _POPULATION_H_
#define _POPULATION_H_

#include <vector>
#include <iostream>
using namespace std;

#include "Individual.h"
#include "Archive.h"
#include "OffspringGenerator.h"

class Archive;

//============================================
//	class Population
//============================================
class Population{
public:

	Population();

	Individual* getPopulation(int i);
	vector<Individual>& getPopulation(){
		return population;
	}
	void evolve(const int& generation);
	void setPopulation(vector<Individual>& archive){
		population.resize(archive.size());
		for(int i=0;i<archive.size();i++){
			population[i]=archive[i];
		}
	}
	
	void setVariablesort(bool flag){
		variablesort = flag;
	}
	
private:
	
	int populationSize;
	int generation;
	bool variablesort;//trueʤ߷ѿ֤Ǥζ˵
	vector<Individual> population;	//õ콸
	
	void mutate();//Ѱۤ
	void crossover(const int& generation);//򺵤
	void repair();//ᤷ
	void evaluate();//ɾ
};

#endif //_POPULATION_H_
